#include "mpi.h"
#include "assert.h"
#include <stdio.h>

int main(int argc, char* argv[]) {
  MPI_Init(&argc, &argv);

  int rank, size;
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  MPI_Status status;

  int msg = 1;

  MPI_Recv(&msg, 1, MPI_INTEGER, (rank-1) % size, 0, MPI_COMM_WORLD, NULL);
  MPI_Send(&msg, 1, MPI_INTEGER, (rank+1) % size, 0, MPI_COMM_WORLD);

  // msg = 0;
  // MPI_Recv(&msg, 1, MPI_INTEGER, (rank-1) % size, 0, MPI_COMM_WORLD, NULL);
  // assert(msg == 1);

  printf("Process %d done.\n", rank);

  MPI_Finalize();
  return 0;
}

